<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyfobEmergencyKey ArrayType
 * @subpackage Arrays
 */
class ArrayOfKeyfobEmergencyKey extends AbstractStructArrayBase
{
    /**
     * The KeyfobEmergencyKey
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\KeyfobEmergencyKey[]
     */
    public $KeyfobEmergencyKey;
    /**
     * Constructor method for ArrayOfKeyfobEmergencyKey
     * @uses ArrayOfKeyfobEmergencyKey::setKeyfobEmergencyKey()
     * @param \CustomerManagement\StructType\KeyfobEmergencyKey[] $keyfobEmergencyKey
     */
    public function __construct(array $keyfobEmergencyKey = array())
    {
        $this
            ->setKeyfobEmergencyKey($keyfobEmergencyKey);
    }
    /**
     * Get KeyfobEmergencyKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey[]|null
     */
    public function getKeyfobEmergencyKey()
    {
        return isset($this->KeyfobEmergencyKey) ? $this->KeyfobEmergencyKey : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyfobEmergencyKey method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyfobEmergencyKey method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyfobEmergencyKeyForArrayConstraintsFromSetKeyfobEmergencyKey(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem instanceof \CustomerManagement\StructType\KeyfobEmergencyKey) {
                $invalidValues[] = is_object($arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem) ? get_class($arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem) : sprintf('%s(%s)', gettype($arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem), var_export($arrayOfKeyfobEmergencyKeyKeyfobEmergencyKeyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyfobEmergencyKey property can only contain items of type \CustomerManagement\StructType\KeyfobEmergencyKey, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyfobEmergencyKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobEmergencyKey[] $keyfobEmergencyKey
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobEmergencyKey
     */
    public function setKeyfobEmergencyKey(array $keyfobEmergencyKey = array())
    {
        // validation for constraint: array
        if ('' !== ($keyfobEmergencyKeyArrayErrorMessage = self::validateKeyfobEmergencyKeyForArrayConstraintsFromSetKeyfobEmergencyKey($keyfobEmergencyKey))) {
            throw new \InvalidArgumentException($keyfobEmergencyKeyArrayErrorMessage, __LINE__);
        }
        if (is_null($keyfobEmergencyKey) || (is_array($keyfobEmergencyKey) && empty($keyfobEmergencyKey))) {
            unset($this->KeyfobEmergencyKey);
        } else {
            $this->KeyfobEmergencyKey = $keyfobEmergencyKey;
        }
        return $this;
    }
    /**
     * Add item to KeyfobEmergencyKey value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobEmergencyKey $item
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobEmergencyKey
     */
    public function addToKeyfobEmergencyKey(\CustomerManagement\StructType\KeyfobEmergencyKey $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\KeyfobEmergencyKey) {
            throw new \InvalidArgumentException(sprintf('The KeyfobEmergencyKey property can only contain items of type \CustomerManagement\StructType\KeyfobEmergencyKey, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyfobEmergencyKey[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\KeyfobEmergencyKey|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyfobEmergencyKey
     */
    public function getAttributeName()
    {
        return 'KeyfobEmergencyKey';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobEmergencyKey
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
